package fr.umlv.lgextract.tools;

import fr.umlv.tatoo.runtime.ast.Node;
import fr.umlv.tatoo.runtime.ast.XMLNodeFactory;

public class XMLFactory extends XMLNodeFactory {
  public XMLFactory() {
    super(AbstractXMLFactory.values());
  }
  private static enum AbstractXMLFactory implements AbstractNodeFactory{
        prop {
      public Node createEmptyNode() {
        return new Prop();
      }
    }  
    ,    header_module {
      public Node createEmptyNode() {
        return new Header_Module();
      }
    }  
    ,    information_star {
      public Node createEmptyNode() {
        return new Information_Star();
      }
    }  
    ,    instruction_star {
      public Node createEmptyNode() {
        return new Instruction_Star();
      }
    }  
    ,    several_features {
      public Node createEmptyNode() {
        return new Several_Features();
      }
    }  
    ,    value_id {
      public Node createEmptyNode() {
        return new Value_Id();
      }
    }  
    ,    feature_value {
      public Node createEmptyNode() {
        return new Feature_Value();
      }
    }  
    ,    infos {
      public Node createEmptyNode() {
        return new Infos();
      }
    }  
    ,    actionInstruction {
      public Node createEmptyNode() {
        return new ActionInstruction();
      }
    }  
    ,    parenthesis {
      public Node createEmptyNode() {
        return new Parenthesis();
      }
    }  
    ,    propactionname_always {
      public Node createEmptyNode() {
        return new Propactionname_Always();
      }
    }  
    ,    otherPropCall {
      public Node createEmptyNode() {
        return new OtherPropCall();
      }
    }  
    ,    list {
      public Node createEmptyNode() {
        return new List();
      }
    }  
    ,    feature_name {
      public Node createEmptyNode() {
        return new Feature_Name();
      }
    }  
    ,    create {
      public Node createEmptyNode() {
        return new Create();
      }
    }  
    ,    value_bool {
      public Node createEmptyNode() {
        return new Value_Bool();
      }
    }  
    ,    define_star {
      public Node createEmptyNode() {
        return new Define_Star();
      }
    }  
    ,    and {
      public Node createEmptyNode() {
        return new And();
      }
    }  
    ,    add_conditional {
      public Node createEmptyNode() {
        return new Add_Conditional();
      }
    }  
    ,    feature_fs {
      public Node createEmptyNode() {
        return new Feature_Fs();
      }
    }  
    ,    obj_feature {
      public Node createEmptyNode() {
        return new Obj_Feature();
      }
    }  
    ,    not {
      public Node createEmptyNode() {
        return new Not();
      }
    }  
    ,    create_conditional {
      public Node createEmptyNode() {
        return new Create_Conditional();
      }
    }  
    ,    obj_fs {
      public Node createEmptyNode() {
        return new Obj_Fs();
      }
    }  
    ,    prop_value {
      public Node createEmptyNode() {
        return new Prop_Value();
      }
    }  
    ,    add {
      public Node createEmptyNode() {
        return new Add();
      }
    }  
    ,    attrib {
      public Node createEmptyNode() {
        return new Attrib();
      }
    }  
    ,    feature_list {
      public Node createEmptyNode() {
        return new Feature_List();
      }
    }  
    ,    fs_simple {
      public Node createEmptyNode() {
        return new Fs_Simple();
      }
    }  
    ,    value {
      public Node createEmptyNode() {
        return new Value();
      }
    }  
    ,    features_feature {
      public Node createEmptyNode() {
        return new Features_Feature();
      }
    }  
    ,    propactionname {
      public Node createEmptyNode() {
        return new Propactionname();
      }
    }  
    ,    empty_list {
      public Node createEmptyNode() {
        return new Empty_List();
      }
    }  
    ,    not_propactionname {
      public Node createEmptyNode() {
        return new Not_Propactionname();
      }
    }  
    ,    define {
      public Node createEmptyNode() {
        return new Define();
      }
    }  
    ,    simplefs {
      public Node createEmptyNode() {
        return new Simplefs();
      }
    }  
    ,    otherActionName {
      public Node createEmptyNode() {
        return new OtherActionName();
      }
    }  
    ,    or {
      public Node createEmptyNode() {
        return new Or();
      }
    }  
    ,    empty_simplefs {
      public Node createEmptyNode() {
        return new Empty_Simplefs();
      }
    }  
    ,    simple_path {
      public Node createEmptyNode() {
        return new Simple_Path();
      }
    }  
    ,    att_star {
      public Node createEmptyNode() {
        return new Att_Star();
      }
    }  
    ,    start {
      public Node createEmptyNode() {
        return new Start();
      }
    }  
    ,    element_star {
      public Node createEmptyNode() {
        return new Element_Star();
      }
    }  
    ,    feature_fs_inherits {
      public Node createEmptyNode() {
        return new Feature_Fs_Inherits();
      }
    }  
    ,    elem {
      public Node createEmptyNode() {
        return new Elem();
      }
    }  
    ,    several_path {
      public Node createEmptyNode() {
        return new Several_Path();
      }
    }  
    ,    obj_list {
      public Node createEmptyNode() {
        return new Obj_List();
      }
    }  
    ,    fs_inherits {
      public Node createEmptyNode() {
        return new Fs_Inherits();
      }
    }  
    ,    info {
      public Node createEmptyNode() {
        return new Info();
      }
    }  
    ,    property_star {
      public Node createEmptyNode() {
        return new Property_Star();
      }
    }  
    ;
    public String getName() {
      return name().replace('_','-');
    }
  }
}
